<script setup lang="ts">
import { ref, onMounted } from 'vue'
import { useI18n } from 'vue-i18n'
import MessageBox, { type MessageBoxOptions } from '../components/MessageBox.vue'
import WaitBox, { type WaitBoxOptions } from '../components/WaitBox.vue'
import MenuBox from './MenuBox.vue'
import PageHeader from './PageHeader.vue'
import PageFooter from './PageFooter.vue'

// using
const { locale } = useI18n()

// props
const props = defineProps<{
	/**
	 * Display title.
	 */
	title?: string

	/**
	 * Hide header.
	 */
	hideHeader?: boolean

	/**
	 * Hide footer.
	 */
	hideFooter?: boolean
}>()

// states
const themeList = ref([
	'blue',
	'green',
	'orange',
])
const toneList = ref([
	'default',
	'dark',
	'lite',
])
const theme = ref('')
const tone = ref('')
const dark = ref(false)
const pageHeader = ref(<InstanceType<typeof PageHeader> | null>null)
const pageFooter = ref(<InstanceType<typeof PageFooter> | null>null)
const messageBox = ref(<InstanceType<typeof MessageBox> | null>null)
const waitBox = ref(<InstanceType<typeof WaitBox> | null>null)
const menuBox = ref(<InstanceType<typeof MenuBox> | null>null)

onMounted(() => {
	onLocale(localStorage.getItem('locale') || 'en')
	onTheme(localStorage.getItem('theme') || '')
	onTone(localStorage.getItem('tone') || '')

	messageBox.value?.setDefaults(<MessageBoxOptions>{
		barrierBackground: '#666c',
		titleBackground: '#336',
		titleColor: '#eef',
		//rightIcon: true,
	})

	waitBox.value?.setDefaults(<WaitBoxOptions>{
		barrierBackground: '#666c',
		edgeBackground: '#333',
		iconColor: '#3c3',
		//rightIcon: true,
	})
})

function onLocale(value: string) {
	// set current locale
	locale.value = value
	console.log(`current locale: ${locale.value}`)

	localStorage.setItem('locale', locale.value)
}

function onTheme(value: string) {
	// validates parameter and reset theme to default if it is not right
	const index = themeList.value.findIndex((e: string) => e === value)
	if (index < 0 || index >= themeList.value.length)
		value = themeList.value[0]

	// set theme
	const root = document.querySelector(':root') as any
	const style = root.style
	style.setProperty(`--c-top-header-bg`, `var(--c-${value}-top-header-bg)`)
	style.setProperty(`--c-top-header-fg`, `var(--c-${value}-top-header-fg)`)
	//
	// NOTE:
	// add more property here...
	//
	document.documentElement.setAttribute('data-theme', value)
	theme.value = value
	console.log(`current theme: ${theme.value}`)

	localStorage.setItem('theme', theme.value)
}

function onTone(value: string) {
	// validates parameter and reset tone to default if it is not right
	const index = toneList.value.findIndex((e: string) => e === value)
	if (index < 0 || index >= toneList.value.length)
		value = toneList.value[0]

	// set tone
	const root = document.querySelector(':root') as any
	const style = root.style
	style.setProperty(`--mode`, `var(--${value}-mode)`)
	style.setProperty(`--c-background`, `var(--c-${value}-background)`)
	style.setProperty(`--c-background-soft`, `var(--c-${value}-background-soft)`)
	style.setProperty(`--c-background-mute`, `var(--c-${value}-background-mute)`)
	style.setProperty(`--c-border`, `var(--c-${value}-border)`)
	style.setProperty(`--c-border-hover`, `var(--c-${value}-border-hover)`)
	style.setProperty(`--c-heading`, `var(--c-${value}-heading)`)
	style.setProperty(`--c-text`, `var(--c-${value}-text)`)
	style.setProperty(`--c-hilite-text`, `var(--c-${value}-hilite-text)`)
	style.setProperty(`--c-link`, `var(--c-${value}-link)`)
	style.setProperty(`--c-link-visited`, `var(--c-${value}-link-visited)`)
	style.setProperty(`--c-link-active`, `var(--c-${value}-link-active)`)
	//
	// NOTE:
	// add more property here...
	//
	document.documentElement.setAttribute('data-tone', value)
	tone.value = value
	const mode = window.getComputedStyle(root).getPropertyValue(`--mode`)
	dark.value = mode == 'dark'
	console.log(`current tone: ${tone.value}, dark mode: ${dark.value}`)

	localStorage.setItem('tone', tone.value)
}

// ----------------------------------------------------------------------

// exposed API
defineExpose({

	getThemeList: function (): Array<string> {
		return themeList.value
	},

	getToneList: function (): Array<string> {
		return toneList.value
	},

	getLocale: function (): string {
		return locale.value
	},

	getTheme: function (): string {
		return theme.value
	},

	getTone: function (): string {
		return tone.value
	},

	getDark: function (): boolean {
		return dark.value
	},

	setLocale: function (value: string): void {
		onLocale(value)
	},

	setTheme: function (value: string): void {
		onTheme(value)
	},

	setTone: function (value: string): void {
		onTone(value)
	},

	usePageHeader: function (): InstanceType<typeof PageHeader> | null {
		return pageHeader.value
	},

	usePageFooter: function (): InstanceType<typeof PageFooter> | null {
		return pageFooter.value
	},

	useMessageBox: function (): InstanceType<typeof MessageBox> | null {
		return messageBox.value
	},

	useWaitBox: function (): InstanceType<typeof WaitBox> | null {
		return waitBox.value
	},

	useMenuBox: function (): InstanceType<typeof MenuBox> | null {
		return menuBox.value
	},

})
</script>


<style scoped>
#body {
	display: flex;
	flex-direction: column;
	height: 100vh;
}

main {
	padding: 2rem 1.5rem;
	flex: 1 0;
}
</style>


<template>
	<div id="body" :class="dark ? 'dark' : 'lite'">
		<PageHeader ref="pageHeader" v-if="!props.hideHeader" :title="title" @profile-menu="menuBox?.open()">
		</PageHeader>

		<main>
			<slot></slot>
		</main>

		<PageFooter ref="pageFooter" v-if="!props.hideFooter"></PageFooter>

		<div>
			<MessageBox ref="messageBox" />
			<WaitBox ref="waitBox" />
			<MenuBox ref="menuBox" @set-locale="onLocale" @set-theme="onTheme" @set-tone="onTone" />
		</div>
	</div>
</template>
